#!/bin/csh -f
#  #!/bin/csh -fx

#  TCppA.csh: translator from C code to TBCppA XML.
#  in TBCppA project: tracer-based CPP analyzer.
#  Copyright (c) 2006   Katsuhiko Gondow (gondow(at)cs.titech.ac.jp)
#  $Id: TBCppA.csh,v 1.1 2006/06/16 15:48:35 gondow Exp gondow $

# Usage: ./TBCppA.csh foo.c

set SRC_FILE      = $1
set XML_FILE      = $1.xml
set TMP_FILE      = .tmpfile
# set TBCPPA_BINDIR = ~/paper/fose06/src2
set TBCPPA_DBDIR  = ./TBCppA

setenv TBCPPA_DIR  $TBCPPA_BINDIR/$TBCPPA_DBDIR

# append $TBCPPA_DIR if not in path
echo $path | grep -q $TBCPPA_BINDIR
if ( $status ) then
  set path=($TBCPPA_BINDIR $path:q)
endif

if ($?TBCPPA_CPPOPT == 0) then
    setenv TBCPPA_CPPOPT 
endif

set CPP_CMD   = "gcc -E -P $TBCPPA_CPPOPT -nostdinc -I$TBCPPA_DIR/usr/include -I$TBCPPA_DIR/usr/lib/gcc/i686-pc-cygwin/3.4.4/include"

tadd.exe      $SRC_FILE
#tadd.exe --conservative     $SRC_FILE
tifdef_src2html.exe  $SRC_FILE
tdbxml.exe    $TBCPPA_DIR/db_file

$CPP_CMD      $TBCPPA_DIR/$SRC_FILE | cat -s | txml.exe | tfix.exe $TMP_FILE
xsltproc $TBCPPA_BINDIR/tstrip.xsl $TMP_FILE > $XML_FILE

#$CPP_CMD      $TBCPPA_DIR/$SRC_FILE | cat -s > foo.E
#txml.exe < foo.E > foo.xml
#tfix.exe foo2.xml < foo.xml
#xsltproc $TBCPPA_BINDIR/tstrip.xsl foo2.xml > $XML_FILE

#end-of-file
